<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsolItem StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ConsolItem
 * @subpackage Structs
 */
class ConsolItem extends AbstractStructBase
{
    /**
     * The AgentType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AgentType;
    /**
     * The AgentsReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AgentsReference;
    /**
     * The Branches
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Branches
     */
    public $Branches;
    /**
     * The CarrierBookingReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CarrierBookingReference;
    /**
     * The ConsolMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ConsolMode;
    /**
     * The ContainerMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContainerMode;
    /**
     * The FirstLegLoadATD
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FirstLegLoadATD;
    /**
     * The FirstLegLoadETD
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FirstLegLoadETD;
    /**
     * The FirstLoadCountry
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FirstLoadCountry;
    /**
     * The FirstLoadPort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FirstLoadPort;
    /**
     * The LastDischargeCountry
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastDischargeCountry;
    /**
     * The LastDischargePort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastDischargePort;
    /**
     * The LastLegDischATA
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastLegDischATA;
    /**
     * The LastLegDischETA
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastLegDischETA;
    /**
     * The MasterBill
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MasterBill;
    /**
     * The ReceiveAgent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReceiveAgent;
    /**
     * The Reference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Reference;
    /**
     * The SendAgent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SendAgent;
    /**
     * The TotalShp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TotalShp;
    /**
     * The TotalShpPacks
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TotalShpPacks;
    /**
     * The TransportMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TransportMode;
    /**
     * Constructor method for ConsolItem
     * @uses ConsolItem::setAgentType()
     * @uses ConsolItem::setAgentsReference()
     * @uses ConsolItem::setBranches()
     * @uses ConsolItem::setCarrierBookingReference()
     * @uses ConsolItem::setConsolMode()
     * @uses ConsolItem::setContainerMode()
     * @uses ConsolItem::setFirstLegLoadATD()
     * @uses ConsolItem::setFirstLegLoadETD()
     * @uses ConsolItem::setFirstLoadCountry()
     * @uses ConsolItem::setFirstLoadPort()
     * @uses ConsolItem::setLastDischargeCountry()
     * @uses ConsolItem::setLastDischargePort()
     * @uses ConsolItem::setLastLegDischATA()
     * @uses ConsolItem::setLastLegDischETA()
     * @uses ConsolItem::setMasterBill()
     * @uses ConsolItem::setReceiveAgent()
     * @uses ConsolItem::setReference()
     * @uses ConsolItem::setSendAgent()
     * @uses ConsolItem::setTotalShp()
     * @uses ConsolItem::setTotalShpPacks()
     * @uses ConsolItem::setTransportMode()
     * @param string $agentType
     * @param string $agentsReference
     * @param \StructType\Branches $branches
     * @param string $carrierBookingReference
     * @param string $consolMode
     * @param string $containerMode
     * @param string $firstLegLoadATD
     * @param string $firstLegLoadETD
     * @param string $firstLoadCountry
     * @param string $firstLoadPort
     * @param string $lastDischargeCountry
     * @param string $lastDischargePort
     * @param string $lastLegDischATA
     * @param string $lastLegDischETA
     * @param string $masterBill
     * @param string $receiveAgent
     * @param string $reference
     * @param string $sendAgent
     * @param string $totalShp
     * @param string $totalShpPacks
     * @param string $transportMode
     */
    public function __construct($agentType = null, $agentsReference = null, \StructType\Branches $branches = null, $carrierBookingReference = null, $consolMode = null, $containerMode = null, $firstLegLoadATD = null, $firstLegLoadETD = null, $firstLoadCountry = null, $firstLoadPort = null, $lastDischargeCountry = null, $lastDischargePort = null, $lastLegDischATA = null, $lastLegDischETA = null, $masterBill = null, $receiveAgent = null, $reference = null, $sendAgent = null, $totalShp = null, $totalShpPacks = null, $transportMode = null)
    {
        $this
            ->setAgentType($agentType)
            ->setAgentsReference($agentsReference)
            ->setBranches($branches)
            ->setCarrierBookingReference($carrierBookingReference)
            ->setConsolMode($consolMode)
            ->setContainerMode($containerMode)
            ->setFirstLegLoadATD($firstLegLoadATD)
            ->setFirstLegLoadETD($firstLegLoadETD)
            ->setFirstLoadCountry($firstLoadCountry)
            ->setFirstLoadPort($firstLoadPort)
            ->setLastDischargeCountry($lastDischargeCountry)
            ->setLastDischargePort($lastDischargePort)
            ->setLastLegDischATA($lastLegDischATA)
            ->setLastLegDischETA($lastLegDischETA)
            ->setMasterBill($masterBill)
            ->setReceiveAgent($receiveAgent)
            ->setReference($reference)
            ->setSendAgent($sendAgent)
            ->setTotalShp($totalShp)
            ->setTotalShpPacks($totalShpPacks)
            ->setTransportMode($transportMode);
    }
    /**
     * Get AgentType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgentType()
    {
        return isset($this->AgentType) ? $this->AgentType : null;
    }
    /**
     * Set AgentType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $agentType
     * @return \StructType\ConsolItem
     */
    public function setAgentType($agentType = null)
    {
        // validation for constraint: string
        if (!is_null($agentType) && !is_string($agentType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agentType, true), gettype($agentType)), __LINE__);
        }
        if (is_null($agentType) || (is_array($agentType) && empty($agentType))) {
            unset($this->AgentType);
        } else {
            $this->AgentType = $agentType;
        }
        return $this;
    }
    /**
     * Get AgentsReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgentsReference()
    {
        return isset($this->AgentsReference) ? $this->AgentsReference : null;
    }
    /**
     * Set AgentsReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $agentsReference
     * @return \StructType\ConsolItem
     */
    public function setAgentsReference($agentsReference = null)
    {
        // validation for constraint: string
        if (!is_null($agentsReference) && !is_string($agentsReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agentsReference, true), gettype($agentsReference)), __LINE__);
        }
        if (is_null($agentsReference) || (is_array($agentsReference) && empty($agentsReference))) {
            unset($this->AgentsReference);
        } else {
            $this->AgentsReference = $agentsReference;
        }
        return $this;
    }
    /**
     * Get Branches value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Branches|null
     */
    public function getBranches()
    {
        return isset($this->Branches) ? $this->Branches : null;
    }
    /**
     * Set Branches value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Branches $branches
     * @return \StructType\ConsolItem
     */
    public function setBranches(\StructType\Branches $branches = null)
    {
        if (is_null($branches) || (is_array($branches) && empty($branches))) {
            unset($this->Branches);
        } else {
            $this->Branches = $branches;
        }
        return $this;
    }
    /**
     * Get CarrierBookingReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCarrierBookingReference()
    {
        return isset($this->CarrierBookingReference) ? $this->CarrierBookingReference : null;
    }
    /**
     * Set CarrierBookingReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $carrierBookingReference
     * @return \StructType\ConsolItem
     */
    public function setCarrierBookingReference($carrierBookingReference = null)
    {
        // validation for constraint: string
        if (!is_null($carrierBookingReference) && !is_string($carrierBookingReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrierBookingReference, true), gettype($carrierBookingReference)), __LINE__);
        }
        if (is_null($carrierBookingReference) || (is_array($carrierBookingReference) && empty($carrierBookingReference))) {
            unset($this->CarrierBookingReference);
        } else {
            $this->CarrierBookingReference = $carrierBookingReference;
        }
        return $this;
    }
    /**
     * Get ConsolMode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getConsolMode()
    {
        return isset($this->ConsolMode) ? $this->ConsolMode : null;
    }
    /**
     * Set ConsolMode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $consolMode
     * @return \StructType\ConsolItem
     */
    public function setConsolMode($consolMode = null)
    {
        // validation for constraint: string
        if (!is_null($consolMode) && !is_string($consolMode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($consolMode, true), gettype($consolMode)), __LINE__);
        }
        if (is_null($consolMode) || (is_array($consolMode) && empty($consolMode))) {
            unset($this->ConsolMode);
        } else {
            $this->ConsolMode = $consolMode;
        }
        return $this;
    }
    /**
     * Get ContainerMode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContainerMode()
    {
        return isset($this->ContainerMode) ? $this->ContainerMode : null;
    }
    /**
     * Set ContainerMode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $containerMode
     * @return \StructType\ConsolItem
     */
    public function setContainerMode($containerMode = null)
    {
        // validation for constraint: string
        if (!is_null($containerMode) && !is_string($containerMode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($containerMode, true), gettype($containerMode)), __LINE__);
        }
        if (is_null($containerMode) || (is_array($containerMode) && empty($containerMode))) {
            unset($this->ContainerMode);
        } else {
            $this->ContainerMode = $containerMode;
        }
        return $this;
    }
    /**
     * Get FirstLegLoadATD value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFirstLegLoadATD()
    {
        return isset($this->FirstLegLoadATD) ? $this->FirstLegLoadATD : null;
    }
    /**
     * Set FirstLegLoadATD value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $firstLegLoadATD
     * @return \StructType\ConsolItem
     */
    public function setFirstLegLoadATD($firstLegLoadATD = null)
    {
        // validation for constraint: string
        if (!is_null($firstLegLoadATD) && !is_string($firstLegLoadATD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstLegLoadATD, true), gettype($firstLegLoadATD)), __LINE__);
        }
        if (is_null($firstLegLoadATD) || (is_array($firstLegLoadATD) && empty($firstLegLoadATD))) {
            unset($this->FirstLegLoadATD);
        } else {
            $this->FirstLegLoadATD = $firstLegLoadATD;
        }
        return $this;
    }
    /**
     * Get FirstLegLoadETD value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFirstLegLoadETD()
    {
        return isset($this->FirstLegLoadETD) ? $this->FirstLegLoadETD : null;
    }
    /**
     * Set FirstLegLoadETD value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $firstLegLoadETD
     * @return \StructType\ConsolItem
     */
    public function setFirstLegLoadETD($firstLegLoadETD = null)
    {
        // validation for constraint: string
        if (!is_null($firstLegLoadETD) && !is_string($firstLegLoadETD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstLegLoadETD, true), gettype($firstLegLoadETD)), __LINE__);
        }
        if (is_null($firstLegLoadETD) || (is_array($firstLegLoadETD) && empty($firstLegLoadETD))) {
            unset($this->FirstLegLoadETD);
        } else {
            $this->FirstLegLoadETD = $firstLegLoadETD;
        }
        return $this;
    }
    /**
     * Get FirstLoadCountry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFirstLoadCountry()
    {
        return isset($this->FirstLoadCountry) ? $this->FirstLoadCountry : null;
    }
    /**
     * Set FirstLoadCountry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $firstLoadCountry
     * @return \StructType\ConsolItem
     */
    public function setFirstLoadCountry($firstLoadCountry = null)
    {
        // validation for constraint: string
        if (!is_null($firstLoadCountry) && !is_string($firstLoadCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstLoadCountry, true), gettype($firstLoadCountry)), __LINE__);
        }
        if (is_null($firstLoadCountry) || (is_array($firstLoadCountry) && empty($firstLoadCountry))) {
            unset($this->FirstLoadCountry);
        } else {
            $this->FirstLoadCountry = $firstLoadCountry;
        }
        return $this;
    }
    /**
     * Get FirstLoadPort value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFirstLoadPort()
    {
        return isset($this->FirstLoadPort) ? $this->FirstLoadPort : null;
    }
    /**
     * Set FirstLoadPort value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $firstLoadPort
     * @return \StructType\ConsolItem
     */
    public function setFirstLoadPort($firstLoadPort = null)
    {
        // validation for constraint: string
        if (!is_null($firstLoadPort) && !is_string($firstLoadPort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstLoadPort, true), gettype($firstLoadPort)), __LINE__);
        }
        if (is_null($firstLoadPort) || (is_array($firstLoadPort) && empty($firstLoadPort))) {
            unset($this->FirstLoadPort);
        } else {
            $this->FirstLoadPort = $firstLoadPort;
        }
        return $this;
    }
    /**
     * Get LastDischargeCountry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastDischargeCountry()
    {
        return isset($this->LastDischargeCountry) ? $this->LastDischargeCountry : null;
    }
    /**
     * Set LastDischargeCountry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastDischargeCountry
     * @return \StructType\ConsolItem
     */
    public function setLastDischargeCountry($lastDischargeCountry = null)
    {
        // validation for constraint: string
        if (!is_null($lastDischargeCountry) && !is_string($lastDischargeCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastDischargeCountry, true), gettype($lastDischargeCountry)), __LINE__);
        }
        if (is_null($lastDischargeCountry) || (is_array($lastDischargeCountry) && empty($lastDischargeCountry))) {
            unset($this->LastDischargeCountry);
        } else {
            $this->LastDischargeCountry = $lastDischargeCountry;
        }
        return $this;
    }
    /**
     * Get LastDischargePort value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastDischargePort()
    {
        return isset($this->LastDischargePort) ? $this->LastDischargePort : null;
    }
    /**
     * Set LastDischargePort value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastDischargePort
     * @return \StructType\ConsolItem
     */
    public function setLastDischargePort($lastDischargePort = null)
    {
        // validation for constraint: string
        if (!is_null($lastDischargePort) && !is_string($lastDischargePort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastDischargePort, true), gettype($lastDischargePort)), __LINE__);
        }
        if (is_null($lastDischargePort) || (is_array($lastDischargePort) && empty($lastDischargePort))) {
            unset($this->LastDischargePort);
        } else {
            $this->LastDischargePort = $lastDischargePort;
        }
        return $this;
    }
    /**
     * Get LastLegDischATA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastLegDischATA()
    {
        return isset($this->LastLegDischATA) ? $this->LastLegDischATA : null;
    }
    /**
     * Set LastLegDischATA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastLegDischATA
     * @return \StructType\ConsolItem
     */
    public function setLastLegDischATA($lastLegDischATA = null)
    {
        // validation for constraint: string
        if (!is_null($lastLegDischATA) && !is_string($lastLegDischATA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastLegDischATA, true), gettype($lastLegDischATA)), __LINE__);
        }
        if (is_null($lastLegDischATA) || (is_array($lastLegDischATA) && empty($lastLegDischATA))) {
            unset($this->LastLegDischATA);
        } else {
            $this->LastLegDischATA = $lastLegDischATA;
        }
        return $this;
    }
    /**
     * Get LastLegDischETA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastLegDischETA()
    {
        return isset($this->LastLegDischETA) ? $this->LastLegDischETA : null;
    }
    /**
     * Set LastLegDischETA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastLegDischETA
     * @return \StructType\ConsolItem
     */
    public function setLastLegDischETA($lastLegDischETA = null)
    {
        // validation for constraint: string
        if (!is_null($lastLegDischETA) && !is_string($lastLegDischETA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastLegDischETA, true), gettype($lastLegDischETA)), __LINE__);
        }
        if (is_null($lastLegDischETA) || (is_array($lastLegDischETA) && empty($lastLegDischETA))) {
            unset($this->LastLegDischETA);
        } else {
            $this->LastLegDischETA = $lastLegDischETA;
        }
        return $this;
    }
    /**
     * Get MasterBill value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMasterBill()
    {
        return isset($this->MasterBill) ? $this->MasterBill : null;
    }
    /**
     * Set MasterBill value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $masterBill
     * @return \StructType\ConsolItem
     */
    public function setMasterBill($masterBill = null)
    {
        // validation for constraint: string
        if (!is_null($masterBill) && !is_string($masterBill)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($masterBill, true), gettype($masterBill)), __LINE__);
        }
        if (is_null($masterBill) || (is_array($masterBill) && empty($masterBill))) {
            unset($this->MasterBill);
        } else {
            $this->MasterBill = $masterBill;
        }
        return $this;
    }
    /**
     * Get ReceiveAgent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReceiveAgent()
    {
        return isset($this->ReceiveAgent) ? $this->ReceiveAgent : null;
    }
    /**
     * Set ReceiveAgent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $receiveAgent
     * @return \StructType\ConsolItem
     */
    public function setReceiveAgent($receiveAgent = null)
    {
        // validation for constraint: string
        if (!is_null($receiveAgent) && !is_string($receiveAgent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($receiveAgent, true), gettype($receiveAgent)), __LINE__);
        }
        if (is_null($receiveAgent) || (is_array($receiveAgent) && empty($receiveAgent))) {
            unset($this->ReceiveAgent);
        } else {
            $this->ReceiveAgent = $receiveAgent;
        }
        return $this;
    }
    /**
     * Get Reference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReference()
    {
        return isset($this->Reference) ? $this->Reference : null;
    }
    /**
     * Set Reference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $reference
     * @return \StructType\ConsolItem
     */
    public function setReference($reference = null)
    {
        // validation for constraint: string
        if (!is_null($reference) && !is_string($reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference, true), gettype($reference)), __LINE__);
        }
        if (is_null($reference) || (is_array($reference) && empty($reference))) {
            unset($this->Reference);
        } else {
            $this->Reference = $reference;
        }
        return $this;
    }
    /**
     * Get SendAgent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSendAgent()
    {
        return isset($this->SendAgent) ? $this->SendAgent : null;
    }
    /**
     * Set SendAgent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sendAgent
     * @return \StructType\ConsolItem
     */
    public function setSendAgent($sendAgent = null)
    {
        // validation for constraint: string
        if (!is_null($sendAgent) && !is_string($sendAgent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sendAgent, true), gettype($sendAgent)), __LINE__);
        }
        if (is_null($sendAgent) || (is_array($sendAgent) && empty($sendAgent))) {
            unset($this->SendAgent);
        } else {
            $this->SendAgent = $sendAgent;
        }
        return $this;
    }
    /**
     * Get TotalShp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTotalShp()
    {
        return isset($this->TotalShp) ? $this->TotalShp : null;
    }
    /**
     * Set TotalShp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $totalShp
     * @return \StructType\ConsolItem
     */
    public function setTotalShp($totalShp = null)
    {
        // validation for constraint: string
        if (!is_null($totalShp) && !is_string($totalShp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($totalShp, true), gettype($totalShp)), __LINE__);
        }
        if (is_null($totalShp) || (is_array($totalShp) && empty($totalShp))) {
            unset($this->TotalShp);
        } else {
            $this->TotalShp = $totalShp;
        }
        return $this;
    }
    /**
     * Get TotalShpPacks value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTotalShpPacks()
    {
        return isset($this->TotalShpPacks) ? $this->TotalShpPacks : null;
    }
    /**
     * Set TotalShpPacks value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $totalShpPacks
     * @return \StructType\ConsolItem
     */
    public function setTotalShpPacks($totalShpPacks = null)
    {
        // validation for constraint: string
        if (!is_null($totalShpPacks) && !is_string($totalShpPacks)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($totalShpPacks, true), gettype($totalShpPacks)), __LINE__);
        }
        if (is_null($totalShpPacks) || (is_array($totalShpPacks) && empty($totalShpPacks))) {
            unset($this->TotalShpPacks);
        } else {
            $this->TotalShpPacks = $totalShpPacks;
        }
        return $this;
    }
    /**
     * Get TransportMode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTransportMode()
    {
        return isset($this->TransportMode) ? $this->TransportMode : null;
    }
    /**
     * Set TransportMode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $transportMode
     * @return \StructType\ConsolItem
     */
    public function setTransportMode($transportMode = null)
    {
        // validation for constraint: string
        if (!is_null($transportMode) && !is_string($transportMode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transportMode, true), gettype($transportMode)), __LINE__);
        }
        if (is_null($transportMode) || (is_array($transportMode) && empty($transportMode))) {
            unset($this->TransportMode);
        } else {
            $this->TransportMode = $transportMode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ConsolItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
